#include <stdio.h>
#include <windows.h>
#include <locale.h>
#include <unistd.h>

//    2 -   

// ---   
int getLogicalDriveStrings() {
    printf("- GetLogicalDriveStrings:\n");
    char buffer[4096]; //    
    DWORD bufSize = sizeof(buffer) - 1; //  ,       

    GetLogicalDriveStrings(bufSize, buffer); //    
    char *drive = buffer;
    while (*drive) { //  
        printf(": %s\n", drive);
        //  
        drive += strlen(drive) + 1;
    }
    return 0;
}
int getVolumeInformation() {
    printf("- GetVolumeInformation:\n");
    char volumeName[256];
    char fileSystemName[256];
    DWORD serialNumber;
    DWORD maxComponentLength;
    DWORD fileSystemFlags;

    //     
    GetVolumeInformation("C:\\", //    ,    
                         volumeName, // ,    
                         sizeof(volumeName), //     
                         &serialNumber,  //   ,     
                         &maxComponentLength, //
                         &fileSystemFlags, //
                         fileSystemName, //     
                         sizeof(fileSystemName)); //     
    printf(" : %s\n", volumeName);
    printf(" : %lu\n", serialNumber);
    printf("Max Component Length: %lu\n", maxComponentLength);
    printf("  : %s\n", fileSystemName);
    printf("File System Flags: %lu\n", fileSystemFlags);
    return 0;
}

// ---
long getFileSize(LPCSTR path) {
    printf("- GetFileSize:\n");
    HANDLE hFile;
    DWORD fileSize;
    unsigned long structLargeInt;
    //  
    hFile = CreateFile(path,
                       GENERIC_READ,
                       FILE_SHARE_READ,
                       NULL,
                       OPEN_EXISTING,
                       FILE_ATTRIBUTE_NORMAL,
                       NULL);

    //   
    structLargeInt = GetFileSize(hFile, NULL);

    //  
    CloseHandle(hFile);

    //   
    printf(" : %lu \n", structLargeInt);
    return 0;
}
int findNextFile() {
    printf("- FindNextFile:\n");
    WIN32_FIND_DATA findData;
    HANDLE hFind;
    char path[MAX_PATH];

    //    ,   
    strcpy(path, "..\\*");

    //    /  
    hFind = FindFirstFile(path, &findData);

    //       
    do {
        if (findData.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY) {
            printf(": %s\n", findData.cFileName);
        } else {
            printf("\t: %s\n", findData.cFileName);
        }
    } while (FindNextFile(hFind, &findData));

    //   
    FindClose(hFind);

    return 0;
}
int getWindowsDirectory() {
    printf("- GetWindowsDirectory:\n");
    char windowsDir[255]; //    

    GetWindowsDirectory(windowsDir, sizeof(windowsDir));

    printf("  : %s\n", windowsDir);
    return 0;
}
int compareFileTime(LPCSTR path_1, LPCSTR path_2)  {
    printf("- CompareFileTime:\n");
    FILETIME fileTime1;
    FILETIME fileTime2;

    //  
    HANDLE file1 =  CreateFile(path_1,
                               GENERIC_READ,
                               FILE_SHARE_READ,
                               NULL,
                               OPEN_EXISTING,
                               FILE_ATTRIBUTE_NORMAL,
                               NULL);

    //    
    GetFileTime(file1, NULL, NULL, &fileTime1);

    //   
    CloseHandle(file1);

    //   
    HANDLE file2 =  CreateFile(path_2,
                               GENERIC_READ,
                               FILE_SHARE_READ,
                               NULL,
                               OPEN_EXISTING,
                               FILE_ATTRIBUTE_NORMAL,
                               NULL);
    //     
    GetFileTime(file2, NULL, NULL, &fileTime2);

    //   
    CloseHandle(file2);

    //    
    int comparisonResult = CompareFileTime(&fileTime1, &fileTime2);

    if (comparisonResult == 1) {
        printf(" 1     2\n");
    } else if (comparisonResult == -1) {
        printf(" 2     1\n");
    } else {
        printf("   \n");
    }

    return 0;
}

// ---
int setLocalTime() {
    printf("- SetLocalTime:\n");
    //   SYSTEMTIME   
    SYSTEMTIME systemTime;

    //   SYSTEMTIME   
    GetLocalTime(&systemTime);
    printf("    : %02d-%02d-%d %02d:%02d:%02d\n",
           systemTime.wDay, systemTime.wMonth, systemTime.wYear,
           systemTime.wHour, systemTime.wMinute, systemTime.wSecond);

    //     1
    if (systemTime.wHour < 23) {
        systemTime.wHour++;
    } else {
        systemTime.wHour = 0;
    }

    //      SetLocalTime
    SetLocalTime(&systemTime);
    printf("  \n");

    printf("    : %02d-%02d-%d %02d:%02d:%02d\n",
           systemTime.wDay, systemTime.wMonth, systemTime.wYear,
           systemTime.wHour, systemTime.wMinute, systemTime.wSecond);

    return 0;
}
void getFileAttributes(LPCSTR path){
    DWORD fileAttributes = GetFileAttributes(path);
    if (fileAttributes & FILE_ATTRIBUTE_READONLY) {
        printf("\n/Read-only");
    }
    if (fileAttributes & FILE_ATTRIBUTE_HIDDEN) {
        printf("\n/Hidden");
    }
    if (fileAttributes & FILE_ATTRIBUTE_DIRECTORY) {
        printf("\n/Directory");
    }//       ...
    printf("\n");
}
int setFileAttributes(LPCSTR path) {

    printf("- SetFileAttributes:\n");
// G  
    //   
    SetFileAttributes(path, (DWORD) NULL);
    //   
    printf("\t    : ");
    getFileAttributes(path);

    //   
    DWORD newFileAttributes = FILE_ATTRIBUTE_READONLY | FILE_ATTRIBUTE_HIDDEN | FILE_ATTRIBUTE_DIRECTORY;
    BOOL result = SetFileAttributes( path, (DWORD) newFileAttributes);

    printf("\t    : ");

    getFileAttributes(path);

    return 0;
}
int createFile() {
    printf("- CreateFile:\n");
    HANDLE hFile;
    char* fileName = "example.txt";

    //  
    hFile = CreateFile(fileName, GENERIC_WRITE, 0, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);

    //   
    char* data = "Hello, World!";
    DWORD bytesWritten;
    WriteFile(hFile, data, strlen(data), &bytesWritten, NULL);

    //  
    CloseHandle(hFile);

    //   
    hFile = CreateFile(fileName, GENERIC_READ, 0, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);

    //   
    const int bufferSize = 100;
    char buffer[bufferSize];
    DWORD bytesRead;
    if (!ReadFile(hFile, buffer, bufferSize, &bytesRead, NULL))
    {
        printf("Failed to read from file.\n");
        CloseHandle(hFile);
        return 1;
    }

    //   
    printf(" : %.*s\n", bytesRead, buffer);

    //  
    CloseHandle(hFile);

    return 0;
}

// ---   
void getKeyboardType(){
    printf("\t- getKeyboardType()\n");
    BYTE typeValue;
    typeValue = GetKeyboardType(0);
    printf("-   :\n");
    switch (typeValue) {
        case 1:
            printf("83-   IBM PC/XT - \n");
            break;
        case 2:
            printf("102-  Olivetti\n");
            break;
        case 3:
            printf("IBM PC/AT -  (84)\n");
            break;
        case 4:
            printf(" IBM- (101-  102 )\n");
            break;
        case 5:
            printf(" Nokia 1050\n");
            break;
        case 6:
            printf(" Nokia 9140\n");
            break;
        case 7:
            printf(" \n");
            break;
        default:
            printf("   \n");
            break;
    }
    printf("   =  %d\n", GetKeyboardType(2L));
} //        
void getKeyboardState(){
    printf("\n\t- getKeyboardState()\n");
    BYTE keyState[256] = {0};

    //    
    GetKeyboardState(keyState);

    //      
    printf("        :\n");
    for (int i = 0; i < 256; i++) {
        if (keyState[i] & 0x80) {
            printf(" %d\n", i);
        }
    }
} //       (  )
// ---   
void getCursorPos(){
    printf("\t- getCursorPos()\n");
    POINT cp;
    GetCursorPos(&cp);
    printf("  : (%ld, %ld)\n", cp.x, cp.y);
} //    
void getCaretBlinkTime(){
    printf("\n\t- getCaretBlinkTime()\n");
    printf("   -  %d\n", GetCaretBlinkTime());
} //     
void getSystemMetrics(){
    printf("\n\t- getSystemMetrics()\n");
    printf("  : %d\n", GetSystemMetrics(SM_CMOUSEBUTTONS));
} //     
// ---  
void showCursor(){
    printf("\t- showCursor()\n");
    printf ("    3 \n");
    // CHAR age;
    // scanf("%c", &age);
    // sleep(1);
    ShowCursor(FALSE);
    // scanf("%c", &age);
    sleep(3);
    ShowCursor(TRUE);
    printf (" \n");
} //    
void swapMouseButton(){
    printf("\n\t- swapMouseButton()\n");
    printf ("  5      \n");
    SwapMouseButton (1);
    sleep(5);
    SwapMouseButton (0);
    printf ("     \n");
} //      
void setCaretBlinkTime(){
    printf("\n\t- setCaretBlinkTime()\n");
    UINT blinkTime = GetCaretBlinkTime();
    UINT blinkTime_old = GetCaretBlinkTime();
    printf ("  5     \n");
    SetCaretBlinkTime(blinkTime / 20);
    sleep(5);
    SetCaretBlinkTime (blinkTime_old);
    printf ("    \n");
    sleep(5);
} //     
void setCursorPos(){
    printf("\n\t- setCursorPos()\n");
    printf("     \n");
    INT y = 0, x = 0;
    sleep(2);
    SetCursorPos(x,y);
    printf("    \n");
} //    
void systemParametersInfo(){
    printf("\n\t- systemParametersInfo()\n");
    PVOID mouseSpeed;
    PVOID mouseSpeed_new = (PVOID) 1;
    //     
    SystemParametersInfo(SPI_GETMOUSESPEED, 0, &mouseSpeed, 0);
    //    
    printf("  : %d\n", mouseSpeed);
    printf("      3 \n");
    sleep(1);
    SystemParametersInfo(SPI_SETMOUSESPEED, 0, mouseSpeed_new, 0);
    sleep(3);
    SystemParametersInfo(SPI_SETMOUSESPEED, 0, mouseSpeed, 0);
    printf("  \n");
} //     

void main() {
    setlocale(LC_ALL, "Rus");

    printf("--------------------------------------------------");
    printf("\n\t\t\t/   :\n");
    getKeyboardType(); // +        
    getKeyboardState(); // +       (  )

    printf("\n--------------------------------------------");
    printf("\n\t\t\t/   :\n");
    getCursorPos(); // +    
    getCaretBlinkTime(); // +     
    getSystemMetrics(); // +     

    printf("\n----------------------------------------------");
    printf("\n\t\t\t/  :\n");
    // showCursor(); // -    
    // swapMouseButton(); // +      
    // setCaretBlinkTime(); // +-     
    // setCursorPos(); // +    
    // systemParametersInfo(); // +     
    printf("\n   Enter\n");
    scanf("%c");
}
